/*
 *  tga.cpp
 *  wavescopeCLI
 *
 *  Created by matti on 12.02.09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef SFXTGA
#define SFXTGA

#include <iostream>
#include <fstream>

using namespace std;

/*
int readshortlittleendian(ifstream infile)
{
	short low, high, result;
	low = infile.get();
	high = infile.get();
	result = low + (high * 256);
	return result;
};
*/

class sfxTGA
	{
	public:
		char * filename;
		unsigned char identsize;
		char * identdata;
		unsigned char colourmaptype;
		unsigned char imagetype;
		short colourmapstart;
		short colourmaplength;
		short colourmapbits;
		short xstart;
		short ystart;
		short width;
		short height;
		unsigned char bits;
		unsigned char descriptor;
		unsigned long datalength;
		unsigned long compresseddatalength;
		int validfile;
		char * data;
		sfxTGA()
		{
			identsize = 0;
			colourmaptype = 0;
			
			imagetype = 2;
			colourmapstart = 0;
			colourmaplength = 0;
			colourmapbits = 0;
			xstart = 0;
			ystart = 0;
			width = 0;
			height = 0;
			bits = 24;
			descriptor =  0;
			datalength = 0;
			compresseddatalength = 0;
			validfile = 0;
		};
		sfxTGA(const sfxTGA &original)
		{
			imagetype = original.imagetype;
			width = original.width;
			height =  original.height;
			bits =  original.bits;
			datalength =  original.datalength;
			data = new char [datalength];
			validfile =  original.validfile;
		};
		~sfxTGA() 
		{
			// if (width>0 && height>0 && data)
			//	delete[] data;
		
		};
		int readfile(char * fn)
		{
			short low, high;
			
			filename = fn;
			
			 ifstream infile(fn, ifstream::binary);
			 
			 if (infile)
			 {
				 identsize = infile.get();
				 colourmaptype = infile.get();
				 imagetype = infile.get();
				 low = infile.get();
				 high = infile.get();
				 colourmapstart = low + 256 * high;
				 low = infile.get();
				 high = infile.get();
				 colourmaplength =  low + 256 * high;
				 colourmapbits =  infile.get();
				 low = infile.get();
				 high = infile.get();
				 xstart =  low + 256 * high;
				 low = infile.get();
				 high = infile.get();
				 ystart =  low + 256 * high;
				 low = infile.get();
				 high = infile.get();
				 width =  low + 256 * high;
				 low = infile.get();
				 high = infile.get();
				 height =  low + 256 * high;
				 bits =  infile.get();
				 descriptor = infile.get();
				 datalength = width*height*bits/8;
				 
				 if (identsize)
				 {
				 	identdata = new char[identsize];
				 	infile.read(identdata,identsize);	 
				 }	
					 
 				 data = new char [datalength];
				 infile.read(data,datalength);
				 
				 if (imagetype == 2 && width>0 && height>0)
				 {
					 compresseddatalength = datalength;
					 validfile = 1;
				 }
				 if (imagetype == 10 && width>0 && height>0)
				 {
					 compresseddatalength = infile.gcount();
					 unpack();
					 validfile = 1;
				 }
				 if (descriptor == 32)
				 {
					 vflip();
					 descriptor = 0;
				 }	
				 infile.close(); 
			 }
			 
			return 0;
			
		};
		int writefile(char * fn)
		{
			unsigned char low, high;
			
			filename = fn;
			
			ofstream outfile(filename, ofstream::binary);
			if (outfile)
			{
				unsigned char colourmapstartl = colourmapstart % 256;
				unsigned char colourmapstarth = colourmapstart >> 8 ;
				unsigned char colourmaplengthl = colourmaplength % 256;
				unsigned char colourmaplengthh = colourmaplength >> 8;
				unsigned char xstartl= xstart % 256;
				unsigned char xstarth = xstart >> 8;
				unsigned char ystartl= ystart % 256;
				unsigned char ystarth = ystart >> 8;
				unsigned char widthl= width % 256;
				unsigned char widthh = width >> 8;
				unsigned char heightl= height % 256;
				unsigned char heighth = height >> 8;
				
				
				outfile << identsize
				<< colourmaptype
				<< imagetype
				<<  colourmapstartl << colourmapstarth
				<<  colourmaplengthl << colourmaplengthh
				<<  char(colourmapbits)
				<<  xstartl << xstarth 
				<<  ystartl << ystarth
				<<  widthl << widthh
				<<  heightl << heighth
				<< char(bits)
				<< char(descriptor);
				outfile.write(data,datalength);
				outfile.close();
			}
			validfile = 1;
			return 0;
		};
		int vflip()
		{
			if (!data) return -1;
			for (int i=0; i<height/2; i++)
			{
				char * swap0 = data + i * width * bits/8;
				char * swap1 = data + (height-i-1) * width * bits/8;
				for (int j=0; j<width * bits/8; j++)
				{
					char temp = *swap0; *swap0 = *swap1; *swap1 = temp;
					swap0++;
					swap1++;
				}
			}
			return 0;
		};
		
		int unpack()
		{
				// TGA has its own RLE
				// wikipedia
				
				/*
				Bei der Lauflängenkodierung wird zeilenweise jeder Satz von Bildpunkten
				von einem zusätzlichen Steuerbyte angeführt. 
				Ist das 8. Bit dieses Steuerbytes gesetzt, so handelt es sich um einen Wiederholungszähler,
				dessen Wert sich aus den unteren 7 Bits erhöht um 1 ergibt. 
				Der nachfolgende Bildpunkt wird entsprechend oft wiederholt. 
				Ist das 8. Bit des Steuerbytes 0, so handelt es sich um einen Datenzähler, 
				dessen Wert sich ebenfalls aus den unteren 7 Bits erhöht um 1 ergibt. 
				Er gibt an, wie viele Bildpunkte in diesem Satz folgen, 
				bevor wieder ein Steuerbyte auftritt. 
				Diese Bildpunkte werden 1:1 übernommen.
				*/
			
			char * bytes = data;
			int newdatalength = width*height*3;
			char * buffer = new char [newdatalength];
			char * bptr = buffer;
			int n;
			unsigned char r,g,b;
			int cc = compresseddatalength;
			int occ = newdatalength;
			int i =0;
			while (cc>0 && occ>0)
			{
				n = (unsigned char)*bytes++;
				cc--;

				if ((n & 0x80) != 0)
				{
					n -= 128;
					n++;
					
					r = *bytes++; g = *bytes++; b = *bytes++;
					cc -= 3;
					
					while (n-- > 0)
					{
						*bptr++ = r; *bptr++ = g; *bptr++ = b;
						occ -= 3;
					}
				}
				else
				{
					n++;
					while (n-- > 0)
					{
						r= *bytes++; g= *bytes++; b= *bytes++;
						*bptr++ = r; *bptr++ = g; *bptr++ = b;
						cc -= 3;
						occ -= 3;
					}
				}
				
				i++;
			}
			
			/*
			if (occ>0)
				cout << " packbits not enough data "<< occ << endl;
			*/
			
			data = new char [newdatalength];
			memcpy (data, buffer, newdatalength);
			
			return 0;
			
		}
		
		int dump()
		{
			cout << "TGA " << filename; 
			if (validfile)
				cout << " valid ";
			else 
				cout << " invalid ";
			cout << width << "x" << height << " " << short(bits) << " bits " << compresseddatalength << "/" << datalength;
			cout << " bytes imagetype " << short(imagetype) ;
			
			if (identsize)
				cout << " (" << identdata << ")";
				
			cout << endl;
			 
			return 0;
		};
		
	};

#endif


